.include "p24Exxxx.inc"

.global _rtsp_ReadConfigWord, _rtsp_ErasePage2, _rtsp_ReadLatch, _rtsp_WriteMem

_rtsp_ReadConfigWord: ;Return: W0=value
	clr TBLPAG
	mov #0xA7FE,W1
	tblrdl [W1],W0
	return

_rtsp_ReadLatch:	;W0=TBLPAG,W1=Wn - returns data in W1:W0
	mov W0,TBLPAG
	tblrdl [W1],W0
	tblrdh [W1],W1
	return

_write:
	push SR
	mov #0xE0, W0	;Disable interrupts
	ior SR

	mov #0x55, W0	;Write the NVM key sequence
	mov W0,NVMKEY
	mov #0xAA, W0
	mov W0,NVMKEY
	bset NVMCON, #15
	nop
	nop

_write_wait:
	btsc NVMCON, #15	;Wait for completion
	bra _write_wait

	pop SR
	return

_rtsp_ErasePage2:	;W0 = offset
	mov W0,NVMADR
	clr NVMADRU
	mov #0x4003,W0
	mov W0,NVMCON
	bra _write

_rtsp_WriteMem:		;W0 = addrhi ;W1 = addrlo
	mov W0,NVMADRU
	mov W1,NVMADR
	mov #0x4001,W0
	mov W0,NVMCON
	bra _write


